Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkIterativeClosestPointTransform Class Reference

`#include <vtkIterativeClosestPointTransform.h>`

Inheritance diagram for vtkIterativeClosestPointTransform:

[legend]
Collaboration diagram for vtkIterativeClosestPointTransform:

[legend]
List of all members.

## Detailed Description

Implementation of the ICP algorithm.

Date:
  2002/01/22 15:30:32

Revision:
  1.8

Match two surfaces using the iterative closest point (ICP) algorithm. The core of the algorithm is to match each vertex in one surface with the closest surface point on the other, then apply the transformation that modify one surface to best match the other (in a least square sense). This has to be iterated to get proper convergence of the surfaces.

Attention:
  Use vtkTransformPolyDataFilter to apply the resulting ICP transform to your data. You might also set it to your actor's user transform.
  This class makes use of vtkLandmarkTransform internally to compute the best fit. Use the GetLandmarkTransform member to get a pointer to that transform and set its parameters. You might, for example, constrain the number of degrees of freedom of the solution (i.e. rigid body, similarity, etc.) by checking the vtkLandmarkTransform documentation for its SetMode member.

See also:
  vtkLandmarkTransform

Created by:
  - Barre, Sebastien

CVS contributions (if > 5%):
  - Barre, Sebastien (94%)

CVS logs (CVSweb):
  - .`cxx` (`/Hybrid/vtkIterativeClosestPointTransform.cxx)`
  - .`h` (`/Hybrid/vtkIterativeClosestPointTransform.h)`

Tests:
  vtkIterativeClosestPointTransform (Tests)

Definition at line 67 of file vtkIterativeClosestPointTransform.h.

## Public Types
typedef vtkLinearTransform | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Inverse ()
vtkAbstractTransform * | MakeTransform ()
void | SetSource (vtkDataSet *source)
void | SetTarget (vtkDataSet *target)
virtual vtkDataSet * | GetSource ()
virtual vtkDataSet * | GetTarget ()
void | SetLocator (vtkCellLocator *locator)
virtual vtkCellLocator * | GetLocator ()
virtual void | SetMaximumNumberOfIterations (int)
virtual int | GetMaximumNumberOfIterations ()
virtual int | GetNumberOfIterations ()
virtual void | SetCheckMeanDistance (int)
virtual int | GetCheckMeanDistance ()
virtual void | CheckMeanDistanceOn ()
virtual void | CheckMeanDistanceOff ()
virtual void | SetMeanDistanceMode (int)
virtual int | GetMeanDistanceMode ()
void | SetMeanDistanceModeToRMS ()
void | SetMeanDistanceModeToAbsoluteValue ()
const char * | GetMeanDistanceModeAsString ()
virtual void | SetMaximumMeanDistance (float)
virtual float | GetMaximumMeanDistance ()
virtual float | GetMeanDistance ()
virtual void | SetMaximumNumberOfLandmarks (int)
virtual int | GetMaximumNumberOfLandmarks ()
virtual void | SetStartByMatchingCentroids (int)
virtual int | GetStartByMatchingCentroids ()
virtual void | StartByMatchingCentroidsOn ()
virtual void | StartByMatchingCentroidsOff ()
virtual vtkLandmarkTransform * | GetLandmarkTransform ()
## Static Public Methods
vtkIterativeClosestPointTransform * | New ()
int | IsTypeOf (const char *type)
vtkIterativeClosestPointTransform * | SafeDownCast (vtkObject *o)
## Protected Methods
void | ReleaseLocator (void)
void | CreateDefaultLocator (void)
unsigned long int | GetMTime ()
| vtkIterativeClosestPointTransform ()
| ~vtkIterativeClosestPointTransform ()
void | InternalUpdate ()
void | InternalDeepCopy (vtkAbstractTransform *transform)
void | ReleaseSource (void)
void | ReleaseTarget (void)
## Protected Attributes
vtkDataSet * | Source
vtkDataSet * | Target
vtkCellLocator * | Locator
int | MaximumNumberOfIterations
int | CheckMeanDistance
int | MeanDistanceMode
float | MaximumMeanDistance
int | MaximumNumberOfLandmarks
int | StartByMatchingCentroids
int | NumberOfIterations
float | MeanDistance
vtkLandmarkTransform * | LandmarkTransform

## Member Typedef Documentation

typedef vtkLinearTransform vtkIterativeClosestPointTransform::Superclass

| Reimplemented from vtkLinearTransform. Definition at line 71 of file vtkIterativeClosestPointTransform.h.

## Constructor & Destructor Documentation

vtkIterativeClosestPointTransform::vtkIterativeClosestPointTransform | ( |  | ) | `[protected]`

vtkIterativeClosestPointTransform::~vtkIterativeClosestPointTransform | ( |  | ) | `[protected]`

## Member Function Documentation

vtkIterativeClosestPointTransform* vtkIterativeClosestPointTransform::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkIterativeClosestPointTransform::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkLinearTransform.

int vtkIterativeClosestPointTransform::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLinearTransform.

virtual int vtkIterativeClosestPointTransform::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkLinearTransform.

vtkIterativeClosestPointTransform* vtkIterativeClosestPointTransform::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkLinearTransform.

void vtkIterativeClosestPointTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkLinearTransform.

void vtkIterativeClosestPointTransform::SetSource | ( | vtkDataSet * | source | ) |

| Specify the source and target data sets.

void vtkIterativeClosestPointTransform::SetTarget | ( | vtkDataSet * | target | ) |

| Specify the source and target data sets.

virtual vtkDataSet* vtkIterativeClosestPointTransform::GetSource | ( |  | ) | `[virtual]`

| Specify the source and target data sets.

virtual vtkDataSet* vtkIterativeClosestPointTransform::GetTarget | ( |  | ) | `[virtual]`

| Specify the source and target data sets.

void vtkIterativeClosestPointTransform::SetLocator | ( | vtkCellLocator * | locator | ) |

| Set/Get a spatial locator for speeding up the search process. An instance of vtkCellLocator is used by default.

virtual vtkCellLocator* vtkIterativeClosestPointTransform::GetLocator | ( |  | ) | `[virtual]`

| Set/Get a spatial locator for speeding up the search process. An instance of vtkCellLocator is used by default.

virtual void vtkIterativeClosestPointTransform::SetMaximumNumberOfIterations | ( | int |  | ) | `[virtual]`

| Set/Get the maximum number of iterations

virtual int vtkIterativeClosestPointTransform::GetMaximumNumberOfIterations | ( |  | ) | `[virtual]`

| Set/Get the maximum number of iterations

virtual int vtkIterativeClosestPointTransform::GetNumberOfIterations | ( |  | ) | `[virtual]`

| Get the number of iterations since the last update

virtual void vtkIterativeClosestPointTransform::SetCheckMeanDistance | ( | int |  | ) | `[virtual]`

| Force the algorithm to check the mean distance between two iteration.

virtual int vtkIterativeClosestPointTransform::GetCheckMeanDistance | ( |  | ) | `[virtual]`

| Force the algorithm to check the mean distance between two iteration.

virtual void vtkIterativeClosestPointTransform::CheckMeanDistanceOn | ( |  | ) | `[virtual]`

| Force the algorithm to check the mean distance between two iteration.

virtual void vtkIterativeClosestPointTransform::CheckMeanDistanceOff | ( |  | ) | `[virtual]`

| Force the algorithm to check the mean distance between two iteration.

virtual void vtkIterativeClosestPointTransform::SetMeanDistanceMode | ( | int |  | ) | `[virtual]`

| Specify the mean distance mode. This mode expresses how the mean distance is computed. The RMS mode is the square root of the average of the sum of squares of the closest point distances. The Absolute Value mode is the mean of the sum of absolute values of the closest point distances.

virtual int vtkIterativeClosestPointTransform::GetMeanDistanceMode | ( |  | ) | `[virtual]`

| Specify the mean distance mode. This mode expresses how the mean distance is computed. The RMS mode is the square root of the average of the sum of squares of the closest point distances. The Absolute Value mode is the mean of the sum of absolute values of the closest point distances.

void vtkIterativeClosestPointTransform::SetMeanDistanceModeToRMS | ( |  | ) | `[inline]`

| Specify the mean distance mode. This mode expresses how the mean distance is computed. The RMS mode is the square root of the average of the sum of squares of the closest point distances. The Absolute Value mode is the mean of the sum of absolute values of the closest point distances. Definition at line 116 of file vtkIterativeClosestPointTransform.h. References VTK_ICP_MODE_RMS.

void vtkIterativeClosestPointTransform::SetMeanDistanceModeToAbsoluteValue | ( |  | ) | `[inline]`

| Specify the mean distance mode. This mode expresses how the mean distance is computed. The RMS mode is the square root of the average of the sum of squares of the closest point distances. The Absolute Value mode is the mean of the sum of absolute values of the closest point distances. Definition at line 118 of file vtkIterativeClosestPointTransform.h. References VTK_ICP_MODE_AV.

const char* vtkIterativeClosestPointTransform::GetMeanDistanceModeAsString | ( |  | ) |

| Specify the mean distance mode. This mode expresses how the mean distance is computed. The RMS mode is the square root of the average of the sum of squares of the closest point distances. The Absolute Value mode is the mean of the sum of absolute values of the closest point distances.

virtual void vtkIterativeClosestPointTransform::SetMaximumMeanDistance | ( | float |  | ) | `[virtual]`

| Set/Get the maximum mean distance between two iteration. If the mean distance is lower than this, the convergence stops.

virtual float vtkIterativeClosestPointTransform::GetMaximumMeanDistance | ( |  | ) | `[virtual]`

| Set/Get the maximum mean distance between two iteration. If the mean distance is lower than this, the convergence stops.

virtual float vtkIterativeClosestPointTransform::GetMeanDistance | ( |  | ) | `[virtual]`

| Get the mean distance between the last two iterations.

virtual void vtkIterativeClosestPointTransform::SetMaximumNumberOfLandmarks | ( | int |  | ) | `[virtual]`

| Set/Get the maximum number of landmarks sampled in your dataset. If your dataset is dense, then you will typically not need all the points to compute the ICP transform.

virtual int vtkIterativeClosestPointTransform::GetMaximumNumberOfLandmarks | ( |  | ) | `[virtual]`

| Set/Get the maximum number of landmarks sampled in your dataset. If your dataset is dense, then you will typically not need all the points to compute the ICP transform.

virtual void vtkIterativeClosestPointTransform::SetStartByMatchingCentroids | ( | int |  | ) | `[virtual]`

| Starts the process by translating source centroid to target centroid.

virtual int vtkIterativeClosestPointTransform::GetStartByMatchingCentroids | ( |  | ) | `[virtual]`

| Starts the process by translating source centroid to target centroid.

virtual void vtkIterativeClosestPointTransform::StartByMatchingCentroidsOn | ( |  | ) | `[virtual]`

| Starts the process by translating source centroid to target centroid.

virtual void vtkIterativeClosestPointTransform::StartByMatchingCentroidsOff | ( |  | ) | `[virtual]`

| Starts the process by translating source centroid to target centroid.

virtual vtkLandmarkTransform* vtkIterativeClosestPointTransform::GetLandmarkTransform | ( |  | ) | `[virtual]`

| Get the internal landmark transform. Use it to constrain the number of degrees of freedom of the solution (i.e. rigid body, similarity, etc.).

void vtkIterativeClosestPointTransform::Inverse | ( |  | ) | `[virtual]`

| Invert the transformation. This is done by switching the source and target. Implements vtkAbstractTransform.

vtkAbstractTransform* vtkIterativeClosestPointTransform::MakeTransform | ( |  | ) | `[virtual]`

| Make another transform of the same type. Implements vtkAbstractTransform.

void vtkIterativeClosestPointTransform::ReleaseSource | ( | void |  | ) | `[protected]`

| Release source and target

void vtkIterativeClosestPointTransform::ReleaseTarget | ( | void |  | ) | `[protected]`

| Release source and target

void vtkIterativeClosestPointTransform::ReleaseLocator | ( | void |  | ) | `[protected]`

| Release locator

void vtkIterativeClosestPointTransform::CreateDefaultLocator | ( | void |  | ) | `[protected]`

| Create default locator. Used to create one when none is specified.

unsigned long int vtkIterativeClosestPointTransform::GetMTime | ( |  | ) | `[protected, virtual]`

| Get the MTime of this object also considering the locator. Reimplemented from vtkAbstractTransform.

void vtkIterativeClosestPointTransform::InternalUpdate | ( |  | ) | `[protected, virtual]`

| Perform any subclass-specific Update. Reimplemented from vtkAbstractTransform.

void vtkIterativeClosestPointTransform::InternalDeepCopy | ( | vtkAbstractTransform * | transform | ) | `[protected, virtual]`

| This method does no type checking, use DeepCopy instead. Reimplemented from vtkHomogeneousTransform.

## Member Data Documentation

vtkDataSet* vtkIterativeClosestPointTransform::Source`[protected]`

| Definition at line 189 of file vtkIterativeClosestPointTransform.h.

vtkDataSet* vtkIterativeClosestPointTransform::Target`[protected]`

| Definition at line 190 of file vtkIterativeClosestPointTransform.h.

vtkCellLocator* vtkIterativeClosestPointTransform::Locator`[protected]`

| Definition at line 191 of file vtkIterativeClosestPointTransform.h.

int vtkIterativeClosestPointTransform::MaximumNumberOfIterations`[protected]`

| Definition at line 192 of file vtkIterativeClosestPointTransform.h.

int vtkIterativeClosestPointTransform::CheckMeanDistance`[protected]`

| Definition at line 193 of file vtkIterativeClosestPointTransform.h.

int vtkIterativeClosestPointTransform::MeanDistanceMode`[protected]`

| Definition at line 194 of file vtkIterativeClosestPointTransform.h.

float vtkIterativeClosestPointTransform::MaximumMeanDistance`[protected]`

| Definition at line 195 of file vtkIterativeClosestPointTransform.h.

int vtkIterativeClosestPointTransform::MaximumNumberOfLandmarks`[protected]`

| Definition at line 196 of file vtkIterativeClosestPointTransform.h.

int vtkIterativeClosestPointTransform::StartByMatchingCentroids`[protected]`

| Definition at line 197 of file vtkIterativeClosestPointTransform.h.

int vtkIterativeClosestPointTransform::NumberOfIterations`[protected]`

| Definition at line 199 of file vtkIterativeClosestPointTransform.h.

float vtkIterativeClosestPointTransform::MeanDistance`[protected]`

| Definition at line 200 of file vtkIterativeClosestPointTransform.h.

vtkLandmarkTransform* vtkIterativeClosestPointTransform::LandmarkTransform`[protected]`

| Definition at line 201 of file vtkIterativeClosestPointTransform.h.

The documentation for this class was generated from the following file:

- Hybrid/vtkIterativeClosestPointTransform.h